
/** intersection.h
 *
 * CS 162 Spring 2011 - Project 1, individual assignment
 *
 * @author Jorge Ortiz <jortiz@eecs.berkeley.edu>
 */


//turn directions
typedef enum {
	LEFT=0,
	RIGHT,
	STRAIGHT
} turn_direction_t;

//car direction
typedef enum {
	NORTH=0,
	SOUTH,
	EAST,
	WEST
} orientation_t;

//fucntion declarations
static void gostraight(orientation_t, unsigned int);
static void turnleft(orientation_t, unsigned int);
static void turnright(orientation_t, unsigned int);
static void * approachintersection(void*);
int createcars(int, char**);

//mutexes
pthread_mutex_t NW_mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t NE_mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t SE_mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t SW_mutex = PTHREAD_MUTEX_INITIALIZER;

/*
	Optional additional code here.
*/

#define lock(CAR, MUTEX) {	      \
    if (pthread_mutex_lock(&MUTEX)) { \
      fprintf(stderr, "pthread_mutex_lock error %d\n", CAR);	\
      exit(-1); \
    } \
  }

#define unlock(CAR, MUTEX) {		\
    if (pthread_mutex_unlock(&MUTEX)) { \
      fprintf(stderr, "pthread_mutex_unlock error %d\n", CAR);	\
      exit(-1); \
    } \
  }
